
_Set_up:

;TEA5767.c,32 :: 		void Set_up() {
;TEA5767.c,34 :: 		ANSEL = 0;
	CLRF       ANSEL+0
;TEA5767.c,35 :: 		ANSELH = 0;      // the rest of the pins set as digital Inputs or outputs.
	CLRF       ANSELH+0
;TEA5767.c,36 :: 		C1ON_bit = 0;    // analog comparators off.
	BCF        C1ON_bit+0, BitPos(C1ON_bit+0)
;TEA5767.c,37 :: 		C2ON_bit = 0;
	BCF        C2ON_bit+0, BitPos(C2ON_bit+0)
;TEA5767.c,38 :: 		CCP1CON = 0;   //PWM1 y PWM2 off.
	CLRF       CCP1CON+0
;TEA5767.c,39 :: 		CCP2CON = 0;
	CLRF       CCP2CON+0
;TEA5767.c,40 :: 		trisc.b3=1;
	BSF        TRISC+0, 3
;TEA5767.c,41 :: 		trisc.b4=1;
	BSF        TRISC+0, 4
;TEA5767.c,42 :: 		TRISD0_bit=1;
	BSF        TRISD0_bit+0, BitPos(TRISD0_bit+0)
;TEA5767.c,43 :: 		TRISD1_bit=1;
	BSF        TRISD1_bit+0, BitPos(TRISD1_bit+0)
;TEA5767.c,44 :: 		I2C1_Init(100000);
	MOVLW      20
	MOVWF      SSPADD+0
	CALL       _I2C1_Init+0
;TEA5767.c,45 :: 		Delay_ms(200);
	MOVLW      3
	MOVWF      R11+0
	MOVLW      8
	MOVWF      R12+0
	MOVLW      119
	MOVWF      R13+0
L_Set_up0:
	DECFSZ     R13+0, 1
	GOTO       L_Set_up0
	DECFSZ     R12+0, 1
	GOTO       L_Set_up0
	DECFSZ     R11+0, 1
	GOTO       L_Set_up0
;TEA5767.c,46 :: 		Lcd_Init();
	CALL       _Lcd_Init+0
;TEA5767.c,47 :: 		Lcd_Cmd(_LCD_CLEAR);
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;TEA5767.c,48 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;TEA5767.c,49 :: 		Lcd_Out(1, 2, "RADIO_FM");
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr1_TEA5767+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;TEA5767.c,50 :: 		Lcd_Out(2, 10, "MHZ");
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      10
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      ?lstr2_TEA5767+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
;TEA5767.c,51 :: 		Delay_ms(10);
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_Set_up1:
	DECFSZ     R13+0, 1
	GOTO       L_Set_up1
	DECFSZ     R12+0, 1
	GOTO       L_Set_up1
	NOP
;TEA5767.c,52 :: 		}
L_end_Set_up:
	RETURN
; end of _Set_up

_tea5767_setFrequency:

;TEA5767.c,54 :: 		void tea5767_setFrequency(double frequency)
;TEA5767.c,56 :: 		unsigned char frequencyH=0;
	CLRF       tea5767_setFrequency_frequencyH_L0+0
	CLRF       tea5767_setFrequency_frequencyL_L0+0
;TEA5767.c,60 :: 		frequencyB=4*(frequency*1000000+225000)/32768;
	MOVF       FARG_tea5767_setFrequency_frequency+0, 0
	MOVWF      R0+0
	MOVF       FARG_tea5767_setFrequency_frequency+1, 0
	MOVWF      R0+1
	MOVF       FARG_tea5767_setFrequency_frequency+2, 0
	MOVWF      R0+2
	MOVF       FARG_tea5767_setFrequency_frequency+3, 0
	MOVWF      R0+3
	MOVLW      0
	MOVWF      R4+0
	MOVLW      36
	MOVWF      R4+1
	MOVLW      116
	MOVWF      R4+2
	MOVLW      146
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVLW      0
	MOVWF      R4+0
	MOVLW      186
	MOVWF      R4+1
	MOVLW      91
	MOVWF      R4+2
	MOVLW      144
	MOVWF      R4+3
	CALL       _Add_32x32_FP+0
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      0
	MOVWF      R4+2
	MOVLW      129
	MOVWF      R4+3
	CALL       _Mul_32x32_FP+0
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      0
	MOVWF      R4+2
	MOVLW      142
	MOVWF      R4+3
	CALL       _Div_32x32_FP+0
	CALL       _double2word+0
;TEA5767.c,61 :: 		frequencyH=frequencyB>>8;
	MOVF       R0+1, 0
	MOVWF      R2+0
	CLRF       R2+1
	MOVF       R2+0, 0
	MOVWF      tea5767_setFrequency_frequencyH_L0+0
;TEA5767.c,62 :: 		frequencyL=frequencyB&0XFF;
	MOVLW      255
	ANDWF      R0+0, 0
	MOVWF      tea5767_setFrequency_frequencyL_L0+0
;TEA5767.c,64 :: 		i2c1_Start();
	CALL       _I2C1_Start+0
;TEA5767.c,65 :: 		i2c1_Wr(TEA5767_W);
	MOVLW      192
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;TEA5767.c,66 :: 		i2c1_Wr(frequencyH);
	MOVF       tea5767_setFrequency_frequencyH_L0+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;TEA5767.c,67 :: 		i2c1_Wr(frequencyL);
	MOVF       tea5767_setFrequency_frequencyL_L0+0, 0
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;TEA5767.c,68 :: 		i2c1_Wr(0xB0);
	MOVLW      176
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;TEA5767.c,69 :: 		i2c1_Wr(0x10);
	MOVLW      16
	MOVWF      FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;TEA5767.c,70 :: 		i2c1_Wr(0x00);
	CLRF       FARG_I2C1_Wr_data_+0
	CALL       _I2C1_Wr+0
;TEA5767.c,71 :: 		i2c1_Stop();
	CALL       _I2C1_Stop+0
;TEA5767.c,72 :: 		Delay_ms(10);
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_tea5767_setFrequency2:
	DECFSZ     R13+0, 1
	GOTO       L_tea5767_setFrequency2
	DECFSZ     R12+0, 1
	GOTO       L_tea5767_setFrequency2
	NOP
;TEA5767.c,73 :: 		}
L_end_tea5767_setFrequency:
	RETURN
; end of _tea5767_setFrequency

_FREQ_FM:

;TEA5767.c,75 :: 		void FREQ_FM() {
;TEA5767.c,77 :: 		FloatToStr(Freq, txt);
	MOVF       _Freq+0, 0
	MOVWF      FARG_FloatToStr_fnum+0
	MOVF       _Freq+1, 0
	MOVWF      FARG_FloatToStr_fnum+1
	MOVF       _Freq+2, 0
	MOVWF      FARG_FloatToStr_fnum+2
	MOVF       _Freq+3, 0
	MOVWF      FARG_FloatToStr_fnum+3
	MOVLW      _txt+0
	MOVWF      FARG_FloatToStr_str+0
	CALL       _FloatToStr+0
;TEA5767.c,78 :: 		txt[5] = 0;
	CLRF       _txt+5
;TEA5767.c,79 :: 		if(Freq<100)Lcd_Out(2,4,txt), Lcd_Chr(2,8,' ');
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      72
	MOVWF      R4+2
	MOVLW      133
	MOVWF      R4+3
	MOVF       _Freq+0, 0
	MOVWF      R0+0
	MOVF       _Freq+1, 0
	MOVWF      R0+1
	MOVF       _Freq+2, 0
	MOVWF      R0+2
	MOVF       _Freq+3, 0
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_FREQ_FM3
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
	MOVLW      2
	MOVWF      FARG_Lcd_Chr_row+0
	MOVLW      8
	MOVWF      FARG_Lcd_Chr_column+0
	MOVLW      32
	MOVWF      FARG_Lcd_Chr_out_char+0
	CALL       _Lcd_Chr+0
	GOTO       L_FREQ_FM4
L_FREQ_FM3:
;TEA5767.c,80 :: 		else Lcd_Out(2,4,txt);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      4
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _txt+0
	MOVWF      FARG_Lcd_Out_text+0
	CALL       _Lcd_Out+0
L_FREQ_FM4:
;TEA5767.c,81 :: 		Delay_ms(10);
	MOVLW      26
	MOVWF      R12+0
	MOVLW      248
	MOVWF      R13+0
L_FREQ_FM5:
	DECFSZ     R13+0, 1
	GOTO       L_FREQ_FM5
	DECFSZ     R12+0, 1
	GOTO       L_FREQ_FM5
	NOP
;TEA5767.c,82 :: 		}
L_end_FREQ_FM:
	RETURN
; end of _FREQ_FM

_main:

;TEA5767.c,84 :: 		void main() {
;TEA5767.c,85 :: 		Set_up();
	CALL       _Set_up+0
;TEA5767.c,86 :: 		tea5767_setFrequency(freq);
	MOVF       _Freq+0, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+0
	MOVF       _Freq+1, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+1
	MOVF       _Freq+2, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+2
	MOVF       _Freq+3, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+3
	CALL       _tea5767_setFrequency+0
;TEA5767.c,87 :: 		FREQ_FM();
	CALL       _FREQ_FM+0
;TEA5767.c,88 :: 		do {
L_main6:
;TEA5767.c,89 :: 		if (Button(&PORTD,1,5,0)) est0=0;      //if the button has been pushed
	MOVLW      PORTD+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      5
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main9
	CLRF       _est0+0
L_main9:
;TEA5767.c,90 :: 		if (est0==0 && Button(&PORTD,1,5,1)){  //and after that the button is free
	MOVF       _est0+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main12
	MOVLW      PORTD+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      5
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main12
L__main25:
;TEA5767.c,91 :: 		Freq=Freq+0.1;                         //increase Freq.
	MOVF       _Freq+0, 0
	MOVWF      R0+0
	MOVF       _Freq+1, 0
	MOVWF      R0+1
	MOVF       _Freq+2, 0
	MOVWF      R0+2
	MOVF       _Freq+3, 0
	MOVWF      R0+3
	MOVLW      205
	MOVWF      R4+0
	MOVLW      204
	MOVWF      R4+1
	MOVLW      76
	MOVWF      R4+2
	MOVLW      123
	MOVWF      R4+3
	CALL       _Add_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _Freq+0
	MOVF       R0+1, 0
	MOVWF      _Freq+1
	MOVF       R0+2, 0
	MOVWF      _Freq+2
	MOVF       R0+3, 0
	MOVWF      _Freq+3
;TEA5767.c,92 :: 		if (Freq>108.0) Freq=88.0;
	MOVF       R0+0, 0
	MOVWF      R4+0
	MOVF       R0+1, 0
	MOVWF      R4+1
	MOVF       R0+2, 0
	MOVWF      R4+2
	MOVF       R0+3, 0
	MOVWF      R4+3
	MOVLW      0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      88
	MOVWF      R0+2
	MOVLW      133
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main13
	MOVLW      0
	MOVWF      _Freq+0
	MOVLW      0
	MOVWF      _Freq+1
	MOVLW      48
	MOVWF      _Freq+2
	MOVLW      133
	MOVWF      _Freq+3
L_main13:
;TEA5767.c,93 :: 		tea5767_setFrequency(Freq);
	MOVF       _Freq+0, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+0
	MOVF       _Freq+1, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+1
	MOVF       _Freq+2, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+2
	MOVF       _Freq+3, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+3
	CALL       _tea5767_setFrequency+0
;TEA5767.c,94 :: 		FREQ_FM();
	CALL       _FREQ_FM+0
;TEA5767.c,95 :: 		est0=1;
	MOVLW      1
	MOVWF      _est0+0
;TEA5767.c,96 :: 		}
L_main12:
;TEA5767.c,97 :: 		if (Button(&PORTD,0,5,0)) est1=0;      //if the button has been pushed
	MOVLW      PORTD+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      5
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main14
	CLRF       _est1+0
L_main14:
;TEA5767.c,98 :: 		if (est1==0 && Button(&PORTD,0,5,1)){  //and after that the button is free
	MOVF       _est1+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main17
	MOVLW      PORTD+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      5
	MOVWF      FARG_Button_time_ms+0
	MOVLW      1
	MOVWF      FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main17
L__main24:
;TEA5767.c,99 :: 		Freq=Freq-0.1;                         //decrease Freq.
	MOVLW      205
	MOVWF      R4+0
	MOVLW      204
	MOVWF      R4+1
	MOVLW      76
	MOVWF      R4+2
	MOVLW      123
	MOVWF      R4+3
	MOVF       _Freq+0, 0
	MOVWF      R0+0
	MOVF       _Freq+1, 0
	MOVWF      R0+1
	MOVF       _Freq+2, 0
	MOVWF      R0+2
	MOVF       _Freq+3, 0
	MOVWF      R0+3
	CALL       _Sub_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _Freq+0
	MOVF       R0+1, 0
	MOVWF      _Freq+1
	MOVF       R0+2, 0
	MOVWF      _Freq+2
	MOVF       R0+3, 0
	MOVWF      _Freq+3
;TEA5767.c,100 :: 		if (Freq<88.0) Freq=108.0;
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      48
	MOVWF      R4+2
	MOVLW      133
	MOVWF      R4+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main18
	MOVLW      0
	MOVWF      _Freq+0
	MOVLW      0
	MOVWF      _Freq+1
	MOVLW      88
	MOVWF      _Freq+2
	MOVLW      133
	MOVWF      _Freq+3
L_main18:
;TEA5767.c,101 :: 		tea5767_setFrequency(Freq);
	MOVF       _Freq+0, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+0
	MOVF       _Freq+1, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+1
	MOVF       _Freq+2, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+2
	MOVF       _Freq+3, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+3
	CALL       _tea5767_setFrequency+0
;TEA5767.c,102 :: 		FREQ_FM();
	CALL       _FREQ_FM+0
;TEA5767.c,103 :: 		est1=1;
	MOVLW      1
	MOVWF      _est1+0
;TEA5767.c,104 :: 		}
L_main17:
;TEA5767.c,105 :: 		if (Button(&PORTD,0,300,0) && Button(&PORTD,1,300,0)){  //Fast mode
	MOVLW      PORTD+0
	MOVWF      FARG_Button_port+0
	CLRF       FARG_Button_pin+0
	MOVLW      44
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
	MOVLW      PORTD+0
	MOVWF      FARG_Button_port+0
	MOVLW      1
	MOVWF      FARG_Button_pin+0
	MOVLW      44
	MOVWF      FARG_Button_time_ms+0
	CLRF       FARG_Button_active_state+0
	CALL       _Button+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main21
L__main23:
;TEA5767.c,106 :: 		Freq=Freq+1.0;
	MOVF       _Freq+0, 0
	MOVWF      R0+0
	MOVF       _Freq+1, 0
	MOVWF      R0+1
	MOVF       _Freq+2, 0
	MOVWF      R0+2
	MOVF       _Freq+3, 0
	MOVWF      R0+3
	MOVLW      0
	MOVWF      R4+0
	MOVLW      0
	MOVWF      R4+1
	MOVLW      0
	MOVWF      R4+2
	MOVLW      127
	MOVWF      R4+3
	CALL       _Add_32x32_FP+0
	MOVF       R0+0, 0
	MOVWF      _Freq+0
	MOVF       R0+1, 0
	MOVWF      _Freq+1
	MOVF       R0+2, 0
	MOVWF      _Freq+2
	MOVF       R0+3, 0
	MOVWF      _Freq+3
;TEA5767.c,107 :: 		if (Freq>108.0) Freq=88.0;
	MOVF       _Freq+0, 0
	MOVWF      R4+0
	MOVF       _Freq+1, 0
	MOVWF      R4+1
	MOVF       _Freq+2, 0
	MOVWF      R4+2
	MOVF       _Freq+3, 0
	MOVWF      R4+3
	MOVLW      0
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVLW      88
	MOVWF      R0+2
	MOVLW      133
	MOVWF      R0+3
	CALL       _Compare_Double+0
	MOVLW      1
	BTFSC      STATUS+0, 0
	MOVLW      0
	MOVWF      R0+0
	MOVF       R0+0, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main22
	MOVLW      0
	MOVWF      _Freq+0
	MOVLW      0
	MOVWF      _Freq+1
	MOVLW      48
	MOVWF      _Freq+2
	MOVLW      133
	MOVWF      _Freq+3
L_main22:
;TEA5767.c,108 :: 		tea5767_setFrequency(Freq);
	MOVF       _Freq+0, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+0
	MOVF       _Freq+1, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+1
	MOVF       _Freq+2, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+2
	MOVF       _Freq+3, 0
	MOVWF      FARG_tea5767_setFrequency_frequency+3
	CALL       _tea5767_setFrequency+0
;TEA5767.c,109 :: 		FREQ_FM();
	CALL       _FREQ_FM+0
;TEA5767.c,110 :: 		}
L_main21:
;TEA5767.c,111 :: 		} while (1);
	GOTO       L_main6
;TEA5767.c,112 :: 		}
L_end_main:
	GOTO       $+0
; end of _main
